﻿Public Class Form1

    Private Sub btnLoop1_Click(sender As System.Object, e As System.EventArgs) Handles btnLoop1.Click
        Dim n As Integer = Val(TextBoxN.Text)
        Dim sum As Integer

        ListBox1.Items.Clear()
        ListBox1.Items.Add("n" & vbTab & "sum")

        ' if n is bigger than 100, this will cause an inifinite loop for values over 100
        While n <> 100
            n = n + 1
            Sum = Sum + n
            ListBox1.Items.Add(n & vbTab & Sum)
        End While
    End Sub

    Private Sub btnLoop2_Click(sender As System.Object, e As System.EventArgs) Handles btnLoop2.Click
        Dim n As Integer = Val(txtN.Text)
        Dim Prod As Long = 1 ' has to be long to allow large numbers and then stop on integer overflow
        ListBox2.Items.Clear()
        ListBox2.Items.Add("n" & vbTab & "Product")

        ' this loop mulltiplies values of N at every increment of 5
        ' the loop terminates when an integer overflow occurs
        Do
            n = n + 5
            Prod = Prod * n
            ListBox2.Items.Add(n & vbTab & Prod)

        Loop Until Prod >= Integer.MaxValue
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoop4.Click
        Dim n As Integer
        Dim repeat As Integer = Val(txtRepeat.Text)
        Dim input As String = txtString.Text
        Dim output As String = String.Empty

        ' this loop repeats a string using string concatenation operator & the required number of times, can repeat as long as there is memory

        Do While n < repeat
            output &= input
            n += 1
        Loop

        lblOut3.Text = output

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoop3.Click
        Dim value As Integer = Val(txtNum.Text)
        Dim counter As Integer = -1 * value
        Dim sum As Integer
        Dim termCond As Boolean

        'this loops sums the Values from -N to N
        ' if N is positive, then from -N to N, and the progress step is a counter increment
        ' if N is negative, then from N to -N, and the progress step is a counter decrement

        ' this loop avoids inifinite loops by making the progress in the correct direction, 

        Do
            sum += value

            If value >= counter Then
                termCond = counter >= value
                counter = counter + 1
            Else
                termCond = counter < value
                counter = counter - 1
            End If
        Loop Until termCond
        lblOut4.Text = sum.ToString

    End Sub

End Class
